MultiDocValues.MultiSortedDocValues (Lucene 10.5.0 core API)
Description: declaration: package: org.apache.lucene.index, class: MultiDocValues, class: MultiSortedDocValues

Package org.apache.lucene.index

# Class MultiDocValues.MultiSortedDocValues

java.lang.Object
org.apache.lucene.search.DocIdSetIterator
org.apache.lucene.index.SortedDocValues
org.apache.lucene.index.MultiDocValues.MultiSortedDocValues

Enclosing class:
  `MultiDocValues`

public static class MultiDocValues.MultiSortedDocValues extends SortedDocValues
Implements SortedDocValues over n subs, using an OrdinalMap

NOTE: This API is for internal purposes only and might change in incompatible ways in the next release.

- ## Field Summary

  Fields
  Modifier and Type
  Field
  Description
  `final int[]`
  `docStarts`
  docbase for each leaf: parallel with `values`
  `final OrdinalMap`
  `mapping`
  ordinal map mapping ords from `values` to global ord space
  `final SortedDocValues[]`
  `values`
  leaf values

  ### Fields inherited from class org.apache.lucene.search.DocIdSetIterator

  `NO_MORE_DOCS`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `MultiSortedDocValues(SortedDocValues[] values, int[] docStarts, OrdinalMap mapping, long totalCost)`
  Creates a new MultiSortedDocValues over `values`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `int`
  `advance(int targetDocID)`
  Advances to the first beyond the current whose document number is greater than or equal to target, and returns the document number itself.
  `boolean`
  `advanceExact(int targetDocID)`
  Advance the iterator to exactly `target` and return whether `target` has a value.
  `long`
  `cost()`
  Returns the estimated cost of this `DocIdSetIterator`.
  `int`
  `docID()`
  Returns the following: `-1` if `DocIdSetIterator.nextDoc()` or `DocIdSetIterator.advance(int)` were not called yet.
  `int`
  `getValueCount()`
  Returns the number of unique values.
  `BytesRef`
  `lookupOrd(int ord)`
  Retrieves the value for the specified ordinal.
  `int`
  `nextDoc()`
  Advances to the next document in the set and returns the doc it is currently on, or `DocIdSetIterator.NO_MORE_DOCS` if there are no more docs in the set.
  NOTE: after the iterator has exhausted you should not call this method, as it may result in unpredicted behavior.
  `int`
  `ordValue()`
  Returns the ordinal for the current docID.

  ### Methods inherited from class org.apache.lucene.index.SortedDocValues

  `intersect, lookupTerm, termsEnum`

  ### Methods inherited from class org.apache.lucene.search.DocIdSetIterator

  `all, docIDRunEnd, empty, intoBitSet, range, slowAdvance`

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Field Details

  - ### docStarts

    public final int[] docStarts
    docbase for each leaf: parallel with `values`

  - ### values

    public final SortedDocValues[] values
    leaf values

  - ### mapping

    public final OrdinalMap mapping
    ordinal map mapping ords from `values` to global ord space

- ## Constructor Details

  - ### MultiSortedDocValues

    public MultiSortedDocValues(SortedDocValues[] values, int[] docStarts, OrdinalMap mapping, long totalCost)
    Creates a new MultiSortedDocValues over `values`

- ## Method Details

  - ### docID

    public int docID()
    Description copied from class: `DocIdSetIterator`
    Returns the following:
    - `-1` if `DocIdSetIterator.nextDoc()` or `DocIdSetIterator.advance(int)` were not called yet.
    - `DocIdSetIterator.NO_MORE_DOCS` if the iterator has exhausted.
    - Otherwise it should return the doc ID it is currently on.
    Specified by:
      `docID` in class `DocIdSetIterator`

  - ### nextDoc

    public int nextDoc() throws IOException
    Description copied from class: `DocIdSetIterator`
    Advances to the next document in the set and returns the doc it is currently on, or `DocIdSetIterator.NO_MORE_DOCS` if there are no more docs in the set.
    NOTE: after the iterator has exhausted you should not call this method, as it may result in unpredicted behavior.
    Specified by:
      `nextDoc` in class `DocIdSetIterator`
    Throws:
      `IOException`

  - ### advance

    public int advance(int targetDocID) throws IOException
    Description copied from class: `DocIdSetIterator`
    Advances to the first beyond the current whose document number is greater than or equal to target, and returns the document number itself. Exhausts the iterator and returns `DocIdSetIterator.NO_MORE_DOCS` if target is greater than the highest document number in the set.

    The behavior of this method is undefined when called with `target ≤ current` , or after the iterator has exhausted. Both cases may result in unpredicted behavior.

    When `target > current` it behaves as if written:

         int advance(int target) {
           int doc;
           while ((doc = nextDoc()) < target) {
           }
           return doc;
         }

    Some implementations are considerably more efficient than that.

    NOTE: this method may be called with `DocIdSetIterator.NO_MORE_DOCS` for efficiency by some Scorers. If your implementation cannot efficiently determine that it should exhaust, it is recommended that you check for that value in each call to this method.

    Specified by:
      `advance` in class `DocIdSetIterator`
    Throws:
      `IOException`

  - ### advanceExact

    public boolean advanceExact(int targetDocID) throws IOException
    Advance the iterator to exactly `target` and return whether `target` has a value. `target` must be greater than or equal to the current `doc ID` and must be a valid doc ID, ie. ≥ 0 and < `maxDoc`. After this method returns, `DocIdSetIterator.docID()` returns `target`.

    Note: it is illegal to call `DocIdSetIterator.intoBitSet(int, org.apache.lucene.util.FixedBitSet, int)` or `DocIdSetIterator.docIDRunEnd()` when this method returns false.

    Throws:
      `IOException`

  - ### ordValue

    public int ordValue() throws IOException
    Description copied from class: `SortedDocValues`
    Returns the ordinal for the current docID. It is illegal to call this method after `advanceExact(int)` returned `false`.
    Specified by:
      `ordValue` in class `SortedDocValues`
    Returns:
      ordinal for the document: this is dense, starts at 0, then increments by 1 for the next value in sorted order.
    Throws:
      `IOException`

  - ### lookupOrd

    public BytesRef lookupOrd(int ord) throws IOException
    Description copied from class: `SortedDocValues`
    Retrieves the value for the specified ordinal. The returned `BytesRef` may be re-used across calls to `SortedDocValues.lookupOrd(int)` so make sure to `copy it` if you want to keep it around.
    Specified by:
      `lookupOrd` in class `SortedDocValues`
    Parameters:
      `ord` - ordinal to lookup (must be >= 0 and < `SortedDocValues.getValueCount()`)
    Throws:
      `IOException`
    See Also:
      - `SortedDocValues.ordValue()`

  - ### getValueCount

    public int getValueCount()
    Description copied from class: `SortedDocValues`
    Returns the number of unique values.
    Specified by:
      `getValueCount` in class `SortedDocValues`
    Returns:
      number of unique values in this SortedDocValues. This is also equivalent to one plus the maximum ordinal.

  - ### cost

    public long cost()
    Description copied from class: `DocIdSetIterator`
    Returns the estimated cost of this `DocIdSetIterator`.

    This is generally an upper bound of the number of documents this iterator might match, but may be a rough heuristic, hardcoded value, or otherwise completely inaccurate.

    Specified by:
      `cost` in class `DocIdSetIterator`